jvx.geom

## Class PwIdentify

- java.lang.Object
- - jv.object.PsObject
  - - jvx.project.PjWorkshop
    - - jvx.geom.PwIdentify

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, PsUpdateIf, PjWorkshopIf

      public class PwIdentify
      extends PjWorkshop

  Utility programs for cleaning and correcting a polyhedral mesh. Contains static functions to operate on a PgElementSet.

  Identification of vertices incorporated into loader manager jv.loader.PgLoader. Therefore functionality to identify vertices moved from jvx.geom.PwCleanMesh to jv.geom.PuCleanMesh.

  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class jv.object.PsObject

      `HAS_BOUNDARY_PANEL, HAS_CONFIG_PANEL, HAS_INFO_PANEL, HAS_LABEL_PANEL, HAS_MATERIAL_PANEL, HAS_TEXTURE_PANEL, HAS_VECTOR_PANEL, INSPECTOR_INFO, INSPECTOR_INFO_EXT, IS_DELETED, IS_FIXED, IS_FOCUSSED, IS_PICKED, IS_SELECTED, IS_USED, NUM_TAGS`

    - ### Fields inherited from interface jv.project.PjWorkshopIf

      `MODE_BUG, MODE_STANDARD, MODE_VALIDATE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PwIdentify()` Constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Close workshop and remove itself as listener from various classes.
    `static int` | `identifyFlatEdges(PgElementSet geom, double eps)` Identify pairs of adjacent elements whose dihedral angle is less than a given threshold.
    `static int` | `identifyFlatRegions(PgElementSet geom, double eps)` Identify flat vertex stars to a single elements if the discrete Gauss curvature is less or equal than a given threshold.
    `static int` | `markFlatEdges(PgElementSet geom, double eps)` Mark pairs of adjacent elements whose dihedral angle is less than a given threshold.
    `static int` | `markFlatRegions(PgElementSet geom, double eps)` Mark flat regions by identifying adjacent elements whose dihedral angle is less or equal than a given threshold.
    `void` | `markVertices(double eps)` Mark vertices which are identical, or within an epsilon box of each other.
    `static void` | `markVertices(PgPointSet geom, double eps)` Mark vertices which are identical, or within an epsilon box of each other.
    `void` | `ok()` Accept the current state of the geometry and close the workshop.
    `void` | `removeMarks()` Remove tag IS_SELECTED from all vertices in geometry.
    `static void` | `removeMarks(PgGeometry geom)` Remove tag IS_SELECTED from all vertices and elements in geometry.
    `void` | `reset()` Reset this workshop to its initial state from which computations can start.

    - ### Methods inherited from class jvx.project.PjWorkshop

      `cancel, getDisplay, getDisplays, getGeometry, getMode, getSavedGeometry, getViewer, init, isModal, isStandalone, removeGeometry, setDisplay, setDisplays, setGeometry, setModal, setMode, setStandalone, setViewer, update`

    - ### Methods inherited from class jv.object.PsObject

      `addInspector, addUpdateListener, assureInspector, clearTag, clone, clone, clone, copy, getFather, getInfoPanel, getInspector, getName, getNumObjects, getSymbol, hasInspector, hasTag, hasUpdateListener, instanceOf, instanceOf, newInspector, newInspector, removeInspector, removeInspector, removeUpdateListener, setName, setParent, setSymbol, setTag, toString, updatePanels`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jv.object.PsUpdateIf

      `getFather, getName, setParent`

- - ### Constructor Detail

    - #### PwIdentify

          public PwIdentify()

      Constructor.

  - ### Method Detail

    - #### reset

          public void reset()

      Reset this workshop to its initial state from which computations can start.
      Overrides:
        `reset` in class `PjWorkshop`

    - #### close

          public void close()

      Close workshop and remove itself as listener from various classes. The workshop will no longer be functional after this call.
      Overrides:
        `close` in class `PjWorkshop`

    - #### ok

          public void ok()

      Accept the current state of the geometry and close the workshop.
      Overrides:
        `ok` in class `PjWorkshop`

    - #### markFlatEdges

          public static int markFlatEdges(PgElementSet geom,
                          double eps)

      Mark pairs of adjacent elements whose dihedral angle is less than a given threshold. Identification at long edges is preferred since presumable for triangles they are diagonals in a quadrilateral.
      Parameters:
        `geom` - geometry whose elements shall be identified
        `eps` - threshold in [0, 180]
      Returns:
        number of removed elements

    - #### identifyFlatEdges

          public static int identifyFlatEdges(PgElementSet geom,
                              double eps)

      Identify pairs of adjacent elements whose dihedral angle is less than a given threshold. Identification at long edges is preferred since presumable for triangles they are diagonals in a quadrilateral.
      Parameters:
        `geom` - geometry whose elements shall be identified
        `eps` - threshold in [0, 180]
      Returns:
        number of removed elements

    - #### identifyFlatRegions

          public static int identifyFlatRegions(PgElementSet geom,
                                double eps)

      Identify flat vertex stars to a single elements if the discrete Gauss curvature is less or equal than a given threshold.
      Parameters:
        `geom` - Geometry whose vertices shall be identified
        `eps` - threshold in [0, 180]
      Returns:
        number of removed elements

    - #### markFlatRegions

          public static int markFlatRegions(PgElementSet geom,
                            double eps)

      Mark flat regions by identifying adjacent elements whose dihedral angle is less or equal than a given threshold.
      Parameters:
        `geom` - Geometry whose vertices shall be identified
        `eps` - threshold in [0, 180]
      Returns:
        number of removed elements

    - #### markVertices

          public void markVertices(double eps)

      Mark vertices which are identical, or within an epsilon box of each other. This is a non-static call for PjWorkshop use.

    - #### markVertices

          public static void markVertices(PgPointSet geom,
                          double eps)

      Mark vertices which are identical, or within an epsilon box of each other.
      Parameters:
        `geom` - Geometry whose vertices shall be marked
        `eps` - tolerance of coordinate components, not distance

    - #### removeMarks

          public void removeMarks()

      Remove tag IS_SELECTED from all vertices in geometry. This is a non-static call for PjWorkshop use.

    - #### removeMarks

          public static void removeMarks(PgGeometry geom)

      Remove tag IS_SELECTED from all vertices and elements in geometry.

"

The software JavaView? is copyright protected. All Rights Reserved.
"